/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package swing.addon.plaf.threeD;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.plaf.*;

final class JBorderSelector extends JButton implements ActionListener, Icon {
	private int bordertype 	= ThreeDUtils.RAISED_THIN;
	private int width			= 50;
	private int height			= 20;
	
	
	public JBorderSelector()  {
		super("");
		
		setIcon(this);
		addActionListener(this);
	}

	public void actionPerformed(ActionEvent e)  {
		JBorderChooser chooser = new JBorderChooser();
		int  type = chooser.showDialog(this, "Choose a border", bordertype);
		if (type != -1) setBorderType(type);
	}

	public int getBorderType()  {
		return bordertype;
	}

	public int getIconHeight()  {
		return height;
	}

	public int getIconWidth()  {
		return width;
	}

	public void paintIcon(Component c, Graphics g, int x, int y)  {
		ThreeDUtils.drawBorder(bordertype, g, x, y, width, height);
	}

	public void setBorderType(int type)  {
		bordertype = type;
	}

}
