/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package swing.addon.plaf.threeD;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.border.*;

class ThreeD_ComboBoxButton extends JButton implements Border, Icon {
	static final int SIZE = 13;
	JComboBox combobox = null;
	
	public ThreeD_ComboBoxButton(JComboBox cbox)  {
		super();
		
		combobox = cbox;
		
		setIcon(this);	// setIcon(new ThreeDIcons.ArrowIcon(ThreeDIcons.DOWN, 7));
		setBorder(this);
	}

	public Insets getBorderInsets(Component c)  {
		return ThreeDUtils.getBorderInsets(ThreeDPrefs.buttonBorderType1);
	}

	public int getIconHeight()  {
		return SIZE;
	}

	public int getIconWidth()  {
		return SIZE;
	}

	public boolean isBorderOpaque()  {
		return true;
	}

	public void paintBorder(Component c, Graphics g, int x, int y, int width, int height)  {
		if (! combobox.isEditable()) return;
		
		JButton button = (JButton)c;
		ButtonModel model = button.getModel();
		
		if (model.isPressed())
			{
			ThreeDUtils.drawBorder(ThreeDPrefs.buttonBorderType2, g, x, y, width, height);
			}
		else
			{
			ThreeDUtils.drawBorder(ThreeDPrefs.buttonBorderType1, g, x, y, width, height);
			}
	}

	public void paintIcon(Component c, Graphics g, int x, int y)  {
		Point p1 = new Point(x, y+3);
		Point p2 = new Point(x+SIZE-1, y+3);
		Point p3 = new Point(x+SIZE/2, y+SIZE-1-3);
		
		Polygon p = new Polygon();
		p.addPoint(p1.x,p1.y);
		p.addPoint(p2.x,p2.y);
		p.addPoint(p3.x,p3.y);
		
		g.setColor(ThreeDPrefs.textColor);
		g.fillPolygon(p);
	}

}
