/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package swing.addon.plaf.threeD;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

class ThreeD_ScrollBarButton extends BasicArrowButton {
	int orientation;
	
	public ThreeD_ScrollBarButton(int orientation)  {
		super(orientation);
		
		this.orientation = orientation;
	}

	public void paint(Graphics g)  {
		Dimension size = getSize();
		
		g.setColor(ThreeDPrefs.backgroundColor);
		g.fillRect(0, 0, size.width, size.height);
		
		if (getModel().isPressed())
			{
			g.setColor(ThreeDPrefs.highlightColor);
			g.fillRect(1, 1, size.width-2, size.height-2);
			ThreeDUtils.drawBorder(ThreeDPrefs.buttonBorderType2, g, 0, 0, size.width, size.height);
			}
		else
			{
			ThreeDUtils.drawBorder(ThreeDPrefs.buttonBorderType1, g, 0, 0, size.width, size.height);
			}
		
		int w = size.width-2;
		int h = size.height-2;
		int arrowHeight = size.height / 4;
		int arrowWidth = size.width / 2;
		int startX=0, startY=0;
		
		g.setColor(ThreeDPrefs.textColor);
		
		switch (orientation)
			{
			case NORTH:
				startY = ((h + 1) - arrowHeight) / 2;
				startX = (w / 2);
				for (int line = 0; line < arrowHeight; line++) g.drawLine(startX - line, startY + line, startX + line + 1, startY + line);
				break;
			case SOUTH:
				startY = (((h + 1) - arrowHeight) / 2) + arrowHeight - 1;
				startX = (w / 2);
				for (int line = 0; line < arrowHeight; line++) g.drawLine(startX - line, startY - line, startX + line + 1, startY - line);
				break;
			case EAST:
				startX = (((w + 1) - arrowHeight) / 2) + arrowHeight - 1;
				startY = (h / 2);
				for (int line = 0; line < arrowHeight; line++) g.drawLine(startX - line, startY - line, startX - line, startY + line + 1);
				break;
			case WEST:
				startX = (((w + 1) - arrowHeight) / 2);
				startY = (h / 2);
				for (int line = 0; line < arrowHeight; line++) g.drawLine(startX + line, startY - line, startX + line, startY + line + 1);
				break;
			}
	}

}
