/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package swing.addon.plaf.threeD;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class ThreeD_ScrollBarUI extends BasicScrollBarUI {
	
	protected JButton createDecreaseButton(int orientation)  {
		return new ThreeD_ScrollBarButton(orientation);
	}

	protected JButton createIncreaseButton(int orientation)  {
		return new ThreeD_ScrollBarButton(orientation);
	}

	public static ComponentUI createUI(JComponent c)  {
		return new ThreeD_ScrollBarUI();
	}

	protected void paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)  {
		Insets i = ThreeDUtils.getBorderInsets(ThreeDPrefs.scrollBarTrackBorderType);
		
		Rectangle draw = thumbRect;
		if (thumbBounds.x == 0 && thumbBounds.y == 0 && thumbBounds.width == 0 && thumbBounds.height == 0) draw = trackRect;
		
		// Ausmalen
		g.setColor(ThreeDPrefs.scrollBarThumbColor);
		g.fillRect(draw.x+i.left, draw.y+i.top, draw.width-i.left-i.right, draw.height-i.top-i.bottom);
		
		// Rahmen zeichnen
		ThreeDUtils.drawBorder(ThreeDPrefs.scrollBarThumbBorderType,  
			g, draw.x+i.left, draw.y+i.top, draw.width-i.left-i.right, draw.height-i.top-i.bottom);
	}

	protected void paintTrack(Graphics g, JComponent c, Rectangle trackBounds)  {
		// Vertiefung ausmalen
		g.setColor(ThreeDPrefs.backgroundColor);
		g.fillRect(0,0,c.getWidth(), c.getHeight());
		
		// Vertiefung einfrben
		g.setColor(ThreeDPrefs.scrollBarTrackColor);
		g.fillRect(trackBounds.x,trackBounds.y,trackBounds.width,trackBounds.height);
		
		// Helle kanten
		ThreeDUtils.drawBorder(ThreeDPrefs.scrollBarTrackBorderType,
			g, trackBounds.x, trackBounds.y, trackBounds.width, trackBounds.height);
	}

}
